Create procedure sp_ConvProc2View
       ( @procName varchar(80),  @viewName varchar(80))
 as
 -- -------------------------------------------------------------
 --  : sp_ConvProc2View
 --  : Eli Leiba
 -- :  ,  
 --    .
 --     SELECT
 -- ------------------------------------------------------------
 begin
   declare @TSQLStmt varchar(500)
   set nocount off
   --   CREATE VIEW tSQL.
   --  OPENROWSET    
   -- (.   SQL server )
   --   SQLOLEDB     
   -- ( Windows)
   --   SET FMTONLY   
   -- (  )
   -- EXEC _   OPENROWSET.
   set @TSQLStmt = 'CREATE VIEW ' + @viewName + ' AS SELECT * FROM '  +
     'OPENROWSET ( '+ '''' +'SQLOLEDB' + ''''+ ','  +
     '''' + 'SERVER=.;Trusted_Connection=yes'+ '''' +',' +
     '''' + 'SET FMTONLY OFF EXEC ' + @procName + ''''+ ')'
   --    
   exec (@TSQLStmt)
   set nocount on
 end
go

--  1:
exec sp_ConvProc2View @procName = 'sp_Lock',   @viewName ='V$LOCK'

--  2:
exec sp_ConvProc2View @procName = 'sp_who',   @viewName ='v$Session'

select * from v$Session  where status like '%background%'

-- 3:

 --    V$LOCK, V$SESSION  sys.objects 
 --     ,   , 
 --  ,   , 
 --       
SELECT.status,S.dbName,S.cmd,O.name, L.TYPE,L.mode,L.status
FROM  V$SESSION S,V$LOCK L, sys.objects O
 where L.OBJID = O.object_id and 
S.SPID = L.SPID
GO
 -- =============================================
 -- =============================================
 -- :        Eli Leiba
 -- :  
 -- =============================================
 CREATE PROCEDURE sp_OutputAndFilterResults
       --      
       @ViewName varchar(50) ,
       @OutputTable varchar(50),
     @WhereClause varchar(50)= NULL
 AS
 BEGIN
    --    
     declare @dropTSQL varchar(100)
     declare @TSQL     varchar(500)
       --  SET NOCOUNT ON     
       --   -    SELECT.
       SET NOCOUNT ON;
     --    ,   .
    -- (        sys.Objects)
     IF EXISTS
       (SELECT *from sys.Objects
         Where name = @OutputTable and
              TYPE_DESC = 'USER_TABLE')
     BEGIN
        SET @dropTSQL = 'drop table ' + @OutputTable
        EXEC(@dropTSQL)
     END
     --   TSQL- select into 
     --   SELECT INTO
     SET @TSQL = 'SELECT * into ' + @OutputTable
                 + ' FROM '+ @ViewName
     --    WHERE,    
     if @WhereClause IS NOT NULL 
     BEGIN
         SET @TSQL = @TSQL + ' WHERE '+ @WhereClause
     END
     --   
     print (@TSQL)
     EXEC (@TSQL)
     --        set nocount
     SET NOCOUNT OFF;
 END
GO

--  4:   

--   v$session   sp_who 
exec sp_ConvProc2View @procName = 'sp_who',@viewName ='v$Session'
--  ,      
--      output_sess
exec sp_OutputAndFilterResults
      @ViewName ='V$SESSION'  ,
      @OutputTable ='output_sess' ,
      @WhereClause ='DBname = ''master'''
 --      output_sess.
 SELECT * FROM output_sess
